# Iran 2005  and 2009 district vote counts

asc <- function(x) { as.character(x) }

asnc <- function(x) { as.numeric(as.character(x)) }

h05 <- c(
"Ahmadinejad.A.pct","Ahmadinejad.A","Rafsanjani.A.pct","Rafsanjani.A",
"unk.A","total.A","invalid.A","ballots.A","unknown.A",
"grand.total",
"Rafsanjani.B.pct","Rafsanjani.B","Ahmadinejad.B.pct","Ahmadinejad.B",
"unk.B","total.B","invalid.B","ballots.B","unknown.B",
"town","province");
dat05 <- read.delim(pipe("awk 'NR>2 {print $0;}' branch.htm.tab"), head=FALSE, col.names=h05);
dat05$total05 <-
  apply(as.matrix(dat05[,c("Ahmadinejad.A","Rafsanjani.A")]),1,sum);
dim(dat05);
names(dat05);
#> dim(dat05);
#[1] 325  22
#> names(dat05);
# [1] "Ahmadinejad.A.pct" "Ahmadinejad.A"     "Rafsanjani.A.pct" 
# [4] "Rafsanjani.A"      "unk.A"             "total.A"          
# [7] "invalid.A"         "ballots.A"         "unknown.A"        
#[10] "grand.total"       "Rafsanjani.B.pct"  "Rafsanjani.B"     
#[13] "Ahmadinejad.B.pct" "Ahmadinejad.B"     "unk.B"            
#[16] "total.B"           "invalid.B"         "ballots.B"        
#[19] "unknown.B"         "town"              "province"         
#[22] "total05"          

sapply(c(1:19,22),function(j){ sum(dat05[,j]) });

dat05R1 <- read.csv("shora-count.csv");
dim(dat05R1);
names(dat05R1);
#> dim(dat05R1);
#[1] 326   7
#> names(dat05R1);
#[1] "mehr_alizadeh" "larijani"      "ghalibaf"      "moeen"        
#[5] "karobi"        "ahmadi_nejad"  "rafsanjani"   

h09 <- c("province","town",
  "Ahmadinejad.old","Rezaei.old","Karoubi.old","Mousavi.old","VG.old","VH.old","total.old",
  "Ahmadinejad","Rezaei","Karoubi","Mousavi","VG","VH","total",paste("d",1:7,sep=""));
dat09 <- read.csv(pipe("awk 'NR>3 {print $0;}' moi-old-vs-new.csv"), head=FALSE, col.names=h09);
dim(dat09);
names(dat09);
#> dim(dat09);
#[1] 366  23
#> names(dat09);
# [1] "province"        "town"            "Ahmadinejad.old" "Rezaei.old"     
# [5] "Karoubi.old"     "Mousavi.old"     "VG.old"          "VH.old"         
# [9] "total.old"       "Ahmadinejad"     "Rezaei"          "Karoubi"        
#[13] "Mousavi"         "VG"              "VH"              "total"          
#[17] "d1"              "d2"              "d3"              "d4"             
#[21] "d5"              "d6"              "d7"             

apply(dat09[,-(1:2)],2,sum);

dat09 <- dat09[,c(1:2,10:16)];
dat09$total09 <-
  apply(as.matrix(dat09[,c("Ahmadinejad","Rezaei","Karoubi","Mousavi")]),1,sum);
dat09$obsnum <- (1:dim(dat09)[1]);

sapply(3:6,function(j){ sum(dat09[,j]) });

moipdat <- read.csv("moi-provinces-districts2.csv",header=FALSE,
  col.names=c("provinceP","townP","province","town"));
dim(moipdat);
names(moipdat);
#> dim(moipdat);
#[1] 366   4
#> names(moipdat);
#[1] "provinceP" "townP"     "province"  "town"     

all(asc(dat09$province)==asc(moipdat$provinceP));
all(asc(dat09$town)==asc(moipdat$townP));

dat09[,c("province","town")] <- moipdat[,c("province","town")];
dat09$provtown <- paste(asc(dat09$province),asc(dat09$town),sep=":");
names(dat09);
#> names(dat09);
# [1] "province"    "town"        "Ahmadinejad" "Rezaei"      "Karoubi"    
# [6] "Mousavi"     "VG"          "VH"          "total"       "total09"    
#[11] "obsnum"      "provtown"   

mtab <- read.delim("mismatch.txt", header=FALSE, col.names=c("obs09","obs05"));
dim(mtab);
names(mtab);
#> dim(mtab);
#[1] 371   2
#> names(mtab);
#[1] "obs09" "obs05"

dat <- data.frame(dat09[mtab[,1],c(11,1:2,12,3:6)],dat05[mtab[,2],c(1:19)],
  dat05R1[-326,][mtab[,2],]);
dim(dat);
names(dat);
#> dim(dat);
#[1] 371  34
#> names(dat);
# [1] "obsnum"            "province"          "town"             
# [4] "provtown"          "Ahmadinejad"       "Rezaei"           
# [7] "Karoubi"           "Mousavi"           "Ahmadinejad.A.pct"
#[10] "Ahmadinejad.A"     "Rafsanjani.A.pct"  "Rafsanjani.A"     
#[13] "unk.A"             "total.A"           "invalid.A"        
#[16] "ballots.A"         "unknown.A"         "grand.total"      
#[19] "Rafsanjani.B.pct"  "Rafsanjani.B"      "Ahmadinejad.B.pct"
#[22] "Ahmadinejad.B"     "unk.B"             "total.B"          
#[25] "invalid.B"         "ballots.B"         "unknown.B"        
#[28] "mehr_alizadeh"     "larijani"          "ghalibaf"         
#[31] "moeen"             "karobi"            "ahmadi_nejad"     
#[34] "rafsanjani"       

idx <- apply(as.matrix(dat[,-(1:2)]),1,function(x){ !any(is.na(x)) });

datuse <- dat[idx,];
datuse$total09 <-
  apply(as.matrix(datuse[,c("Ahmadinejad","Rezaei","Karoubi","Mousavi")]),1,sum);
datuse$total05 <-
  apply(as.matrix(datuse[,c("Ahmadinejad.A","Rafsanjani.A")]),1,sum);
dim(datuse);
names(datuse);
#> dim(datuse);
#[1] 320  36
#> names(datuse);
# [1] "obsnum"            "province"          "town"             
# [4] "provtown"          "Ahmadinejad"       "Rezaei"           
# [7] "Karoubi"           "Mousavi"           "Ahmadinejad.A.pct"
#[10] "Ahmadinejad.A"     "Rafsanjani.A.pct"  "Rafsanjani.A"     
#[13] "unk.A"             "total.A"           "invalid.A"        
#[16] "ballots.A"         "unknown.A"         "grand.total"      
#[19] "Rafsanjani.B.pct"  "Rafsanjani.B"      "Ahmadinejad.B.pct"
#[22] "Ahmadinejad.B"     "unk.B"             "total.B"          
#[25] "invalid.B"         "ballots.B"         "unknown.B"        
#[28] "mehr_alizadeh"     "larijani"          "ghalibaf"         
#[31] "moeen"             "karobi"            "ahmadi_nejad"     
#[34] "rafsanjani"        "total09"           "total05"          

getdigits <- function(num,digit) {
  s <- as.character(num);
  idx <- sapply(s, function(x){ nchar(x) >= digit; });
  dout <- ifelse(idx, NA, "");
  if (any(idx)) {
    dout[idx] <- sapply(s[idx], function(x){ substr(x,digit,digit) });
  }
  return(dout);
}

# Benford's Law probablity formulas
# source
# http://www.mathpages.com/home/kmath302/kmath302.htm
#
# PndB:  d, digit value (vector);  n, digit place;  B, base
# probability that the n-th digit following the first nonzero digit is d,
#   for numbers in base B
# d can be a vector;  n and B must be positive scalars
#
PndB <- function(d,n,B=10) {
  if (n==0) {
    p <- log(1+1/d)/log(B);
  }
  else {
    seq <- B^(n-1):(B^n-1);
    p <- d*0;
    for (i in 1:length(d)) {
      p[i] <- sum(log(1+1/(d[i]+seq*B)))/log(B);
    }
  }
  return(p);
}

runtest <- function(wrk, digit=2) {
  least <- ifelse(digit==1, 1, 0);  # initial digit for Benford test
  vec <- least:9;
  set <- rep(0,length(vec));
  names(set) <- as.character(vec);
  ndtable <- names(dtable <- table(getdigits(wrk, digit=digit)));
  set[ndtable[ndtable %in% vec]] <- dtable[ndtable[ndtable %in% vec]];
  sumset <- sum(set);
  # Benford's law logarithmic distribution test
  bpred <- sumset*PndB(vec, digit-1);
  chi <- sum(dev <- (set - bpred)^2 / bpred);
  dev <- sign(set - bpred) * sqrt(dev);
  # uniform distribution test
  upred <- rep(ifelse(digit==1,1/9,.1), ifelse(digit==1,9,10))*sumset;
  chiU <- sum((set - upred)^2 / upred);
#  if(is.na(chi)) print( table(getdigits(wrk, digit=digit)) );
  return(list(dtable=dtable, sumset=sumset, chiU=chiU, chi=chi, dev=dev));
}

# 2d digit Benford frequencies
benf2 <- PndB(0:9,1);
names(benf2) <- as.character(0:9);

# 2d digit Benford mean
print(benf2mean <- c(benf2 %*% 0:9));


#plot(datuse$Ahmadinejad.A,datuse$Ahmadinejad);
#plot(datuse$Ahmadinejad.A/datuse$total05,datuse$Ahmadinejad/datuse$total09);

vnames <- names(datuse)[c(3:6,8,10)];

digit <- matrix(NA, dim(datuse)[1], length(vnames));
dimnames(digit)[[2]] <- vnames;

for (j in vnames) digit[,j] <- as.numeric(getdigits(datuse[,j], digit=2));

dimnames(digit)[[2]] <- paste("d",vnames,sep="");
datuse <- cbind(datuse,digit);

logistic <- function(x) { 1/(1+exp(-x)) }
logit <- function(x) { log(x/(1-x)) }

library(multinomRob);

# cross-year models

datuse$total05R1 <- 
apply(as.matrix(datuse[,
  c("mehr_alizadeh","larijani","ghalibaf","moeen","karobi","ahmadi_nejad","rafsanjani")]),1,sum);
datuse[,
  c("mehr_alizadeh","larijani","ghalibaf","moeen","karobi","ahmadi_nejad","rafsanjani")] <-
datuse[,
  c("mehr_alizadeh","larijani","ghalibaf","moeen","karobi","ahmadi_nejad","rafsanjani")]/
  datuse$total05R1;
datuse[,
  c("Llarijani","Lghalibaf","Lmoeen","Lkarobi","Lahmadi_nejad","Lrafsanjani")] <-
log(datuse[,
  c("larijani","ghalibaf","moeen","karobi","ahmadi_nejad","rafsanjani")]/
  datuse[,"mehr_alizadeh"]);

datuse$ratio0905 <- datuse$total09/datuse$total05;
datuse$logratio0905 <- log(datuse$total09/datuse$total05);

# 2005 R1 vote * 2009/2005 total ratio

datuse$ratio0905 <- datuse$total09/datuse$total05;
datuse$logratio0905 <- log(datuse$total09/datuse$total05);

m0509ar <- multinomRob(list(
  Ahmadinejad ~ Llarijani*ratio0905 + Lghalibaf*ratio0905 + Lmoeen*ratio0905 +
    Lkarobi*ratio0905 + Lahmadi_nejad*ratio0905 + Lrafsanjani*ratio0905,
  Rezaei ~ Llarijani*ratio0905 + Lghalibaf*ratio0905 + Lmoeen*ratio0905 +
    Lkarobi*ratio0905 + Lahmadi_nejad*ratio0905 + Lrafsanjani*ratio0905,
  Karoubi ~ Llarijani*ratio0905 + Lghalibaf*ratio0905 + Lmoeen*ratio0905 +
    Lkarobi*ratio0905 + Lahmadi_nejad*ratio0905 + Lrafsanjani*ratio0905,
  Mousavi ~ 0), datuse, MLEonly=TRUE);
summary(m0509ar);
m0509ar <- multinomRob(list(
  Ahmadinejad ~ Llarijani*ratio0905 + Lghalibaf*ratio0905 + Lmoeen*ratio0905 +
    Lkarobi*ratio0905 + Lahmadi_nejad*ratio0905 + Lrafsanjani*ratio0905,
  Rezaei ~ Llarijani*ratio0905 + Lghalibaf*ratio0905 + Lmoeen*ratio0905 +
    Lkarobi*ratio0905 + Lahmadi_nejad*ratio0905 + Lrafsanjani*ratio0905,
  Karoubi ~ Llarijani*ratio0905 + Lghalibaf*ratio0905 + Lmoeen*ratio0905 +
    Lkarobi*ratio0905 + Lahmadi_nejad*ratio0905 + Lrafsanjani*ratio0905,
  Mousavi ~ 0), datuse,
  start=
 c( 1.2500, -0.0337, -0.4880, 0.0708, -0.5890, 0.0899, 0.3050, 0.2380,
 0.0474, 0.1230, 0.1030, 0.0482, -0.1200, -0.2160, -3.4500, -0.0112,
 -0.0269, -0.2260, -0.5490, 0.6770, 0.5210, -0.3530, 0.0194, 0.2690,
 0.2040, -0.4270, -0.1210, 0.1380, -4.27000, -0.27500, 0.21600,
 -0.44300, 0.58600, 0.00915, 0.58000, -0.24100, 0.24000, 0.28900,
 -0.47700, 0.32500, -0.40600, -0.04790),
  print=3,
  genoud.parms=list(max.generations=1,hard.generation.limit=TRUE));
summary(m0509ar);

# outliers from constant-vote-proportion model
linpred <- exp(cbind(1,
  as.matrix(datuse[,c("Llarijani","ratio0905","Lghalibaf","Lmoeen","Lkarobi","Lahmadi_nejad",
    "Lrafsanjani")]),
  as.matrix(datuse[,c("Llarijani","Lghalibaf","Lmoeen","Lkarobi","Lahmadi_nejad",
    "Lrafsanjani")])*datuse[,"ratio0905"] ) %*%
  m0509ar$coefficients);
pmat <- linpred/apply(linpred,1,sum);
rmat <-
  as.matrix(datuse[,c("Ahmadinejad","Rezaei","Karoubi","Mousavi")])/datuse$total09-pmat;
widx <- apply(m0509ar$weights[,-1]==0,1,any);
usermat <- rmat;
usermat[m0509ar$weights[,-1]!=0] <- NA;
tmat <- cbind(datuse$obsnum[widx], usermat[widx,]);
dimnames(tmat)[[1]] <- datuse$provtown[widx];
tmat;

# downweighted obs from constant-vote-proportion model
widx <- apply(m0509ar$weights[,-1]<1,1,any);
usermat <- rmat;
usermat[m0509ar$weights[,-1]==1] <- NA;
tmat <- cbind(datuse$obsnum[widx], usermat[widx,]);
dimnames(tmat)[[1]] <- datuse$provtown[widx];
tmat;
