# Iran 2005  and 2009 district vote counts

asc <- function(x) { as.character(x) }

asnc <- function(x) { as.numeric(as.character(x)) }

h05 <- c(
"Ahmadinejad.A.pct","Ahmadinejad.A","Rafsanjani.A.pct","Rafsanjani.A",
"unk.A","total.A","invalid.A","ballots.A","unknown.A",
"grand.total",
"Rafsanjani.B.pct","Rafsanjani.B","Ahmadinejad.B.pct","Ahmadinejad.B",
"unk.B","total.B","invalid.B","ballots.B","unknown.B",
"town","province");
dat05 <- read.delim(pipe("awk 'NR>2 {print $0;}' branch.htm.tab"), head=FALSE, col.names=h05);
dat05$total05 <-
  apply(as.matrix(dat05[,c("Ahmadinejad.A","Rafsanjani.A")]),1,sum);
dim(dat05);
names(dat05);
#> dim(dat05);
#[1] 325  22
#> names(dat05);
# [1] "Ahmadinejad.A.pct" "Ahmadinejad.A"     "Rafsanjani.A.pct" 
# [4] "Rafsanjani.A"      "unk.A"             "total.A"          
# [7] "invalid.A"         "ballots.A"         "unknown.A"        
#[10] "grand.total"       "Rafsanjani.B.pct"  "Rafsanjani.B"     
#[13] "Ahmadinejad.B.pct" "Ahmadinejad.B"     "unk.B"            
#[16] "total.B"           "invalid.B"         "ballots.B"        
#[19] "unknown.B"         "town"              "province"         
#[22] "total05"          

sapply(c(1:19,22),function(j){ sum(dat05[,j]) });

dat05R1 <- read.csv("shora-count.csv");
dim(dat05R1);
names(dat05R1);
#> dim(dat05R1);
#[1] 326   7
#> names(dat05R1);
#[1] "mehr_alizadeh" "larijani"      "ghalibaf"      "moeen"        
#[5] "karobi"        "ahmadi_nejad"  "rafsanjani"   

h09 <- c("province","town","Ahmadinejad","Rezaei","Karoubi","Mousavi","ballots","invalid","total");
dat09 <- read.csv(pipe("awk 'NR>3 {print $0;}' Iran2009.csv"), head=FALSE, col.names=h09);
dat09$total09 <-
  apply(as.matrix(dat09[,c("Ahmadinejad","Rezaei","Karoubi","Mousavi")]),1,sum);
dat09$obsnum <- (1:dim(dat09)[1]);
dim(dat09);
names(dat09);
#> dim(dat09);
#[1] 366   11
#> names(dat09);
#[1] "province"    "town"        "Ahmadinejad" "Rezaei"      "Karoubi"    
#[6] "Mousavi"     "ballots"     "invalid"     "total"       "total09"    
#[11] "obsnum"     

sapply(3:6,function(j){ sum(dat09[,j]) });

mtab <- read.delim("mismatch.txt", header=FALSE, col.names=c("obs09","obs05"));
dim(mtab);
names(mtab);
#> dim(mtab);
#[1] 371   2
#> names(mtab);
#[1] "obs09" "obs05"

dat <- data.frame(dat09[mtab[,1],c(11,1:2,3:6)],dat05[mtab[,2],c(1:19)],
  dat05R1[-326,][mtab[,2],]);
dim(dat);
names(dat);
#> dim(dat);
#[1] 371  33
#> names(dat);
# [1] "obsnum"            "province"          "town"             
# [4] "Ahmadinejad"       "Rezaei"            "Karoubi"          
# [7] "Mousavi"           "Ahmadinejad.A.pct" "Ahmadinejad.A"    
#[10] "Rafsanjani.A.pct"  "Rafsanjani.A"      "unk.A"            
#[13] "total.A"           "invalid.A"         "ballots.A"        
#[16] "unknown.A"         "grand.total"       "Rafsanjani.B.pct" 
#[19] "Rafsanjani.B"      "Ahmadinejad.B.pct" "Ahmadinejad.B"    
#[22] "unk.B"             "total.B"           "invalid.B"        
#[25] "ballots.B"         "unknown.B"         "mehr_alizadeh"    
#[28] "larijani"          "ghalibaf"          "moeen"            
#[31] "karobi"            "ahmadi_nejad"      "rafsanjani"       

idx <- apply(as.matrix(dat[,-(1:2)]),1,function(x){ !any(is.na(x)) });

datuse <- dat[idx,];
datuse$total09 <-
  apply(as.matrix(datuse[,c("Ahmadinejad","Rezaei","Karoubi","Mousavi")]),1,sum);
datuse$total05 <-
  apply(as.matrix(datuse[,c("Ahmadinejad.A","Rafsanjani.A")]),1,sum);
dim(datuse);
names(datuse);
#> dim(datuse);
#[1] 320  35
#> names(datuse);
# [1] "obsnum"            "province"          "town"             
# [4] "Ahmadinejad"       "Rezaei"            "Karoubi"          
# [7] "Mousavi"           "Ahmadinejad.A.pct" "Ahmadinejad.A"    
#[10] "Rafsanjani.A.pct"  "Rafsanjani.A"      "unk.A"            
#[13] "total.A"           "invalid.A"         "ballots.A"        
#[16] "unknown.A"         "grand.total"       "Rafsanjani.B.pct" 
#[19] "Rafsanjani.B"      "Ahmadinejad.B.pct" "Ahmadinejad.B"    
#[22] "unk.B"             "total.B"           "invalid.B"        
#[25] "ballots.B"         "unknown.B"         "mehr_alizadeh"    
#[28] "larijani"          "ghalibaf"          "moeen"            
#[31] "karobi"            "ahmadi_nejad"      "rafsanjani"       
#[34] "total09"           "total05"          

getdigits <- function(num,digit) {
  s <- as.character(num);
  idx <- sapply(s, function(x){ nchar(x) >= digit; });
  dout <- ifelse(idx, NA, "");
  if (any(idx)) {
    dout[idx] <- sapply(s[idx], function(x){ substr(x,digit,digit) });
  }
  return(dout);
}

# Benford's Law probablity formulas
# source
# http://www.mathpages.com/home/kmath302/kmath302.htm
#
# PndB:  d, digit value (vector);  n, digit place;  B, base
# probability that the n-th digit following the first nonzero digit is d,
#   for numbers in base B
# d can be a vector;  n and B must be positive scalars
#
PndB <- function(d,n,B=10) {
  if (n==0) {
    p <- log(1+1/d)/log(B);
  }
  else {
    seq <- B^(n-1):(B^n-1);
    p <- d*0;
    for (i in 1:length(d)) {
      p[i] <- sum(log(1+1/(d[i]+seq*B)))/log(B);
    }
  }
  return(p);
}

runtest <- function(wrk, digit=2) {
  least <- ifelse(digit==1, 1, 0);  # initial digit for Benford test
  vec <- least:9;
  set <- rep(0,length(vec));
  names(set) <- as.character(vec);
  ndtable <- names(dtable <- table(getdigits(wrk, digit=digit)));
  set[ndtable[ndtable %in% vec]] <- dtable[ndtable[ndtable %in% vec]];
  sumset <- sum(set);
  # Benford's law logarithmic distribution test
  bpred <- sumset*PndB(vec, digit-1);
  chi <- sum(dev <- (set - bpred)^2 / bpred);
  dev <- sign(set - bpred) * sqrt(dev);
  # uniform distribution test
  upred <- rep(ifelse(digit==1,1/9,.1), ifelse(digit==1,9,10))*sumset;
  chiU <- sum((set - upred)^2 / upred);
#  if(is.na(chi)) print( table(getdigits(wrk, digit=digit)) );
  return(list(dtable=dtable, sumset=sumset, chiU=chiU, chi=chi, dev=dev));
}

# 2d digit Benford frequencies
benf2 <- PndB(0:9,1);
names(benf2) <- as.character(0:9);

# 2d digit Benford mean
print(benf2mean <- c(benf2 %*% 0:9));


#plot(datuse$Ahmadinejad.A,datuse$Ahmadinejad);
#plot(datuse$Ahmadinejad.A/datuse$total05,datuse$Ahmadinejad/datuse$total09);

vnames <- names(datuse)[c(3:6,8,10)];

digit <- matrix(NA, dim(datuse)[1], length(vnames));
dimnames(digit)[[2]] <- vnames;

for (j in vnames) digit[,j] <- as.numeric(getdigits(datuse[,j], digit=2));

dimnames(digit)[[2]] <- paste("d",vnames,sep="");
datuse <- cbind(datuse,digit);

logistic <- function(x) { 1/(1+exp(-x)) }
logit <- function(x) { log(x/(1-x)) }

library(multinomRob);

# cross-year models

datuse$total05R1 <- 
apply(as.matrix(datuse[,
  c("mehr_alizadeh","larijani","ghalibaf","moeen","karobi","ahmadi_nejad","rafsanjani")]),1,sum);
datuse[,
  c("mehr_alizadeh","larijani","ghalibaf","moeen","karobi","ahmadi_nejad","rafsanjani")] <-
datuse[,
  c("mehr_alizadeh","larijani","ghalibaf","moeen","karobi","ahmadi_nejad","rafsanjani")]/
  datuse$total05R1;
datuse[,
  c("Llarijani","Lghalibaf","Lmoeen","Lkarobi","Lahmadi_nejad","Lrafsanjani")] <-
log(datuse[,
  c("larijani","ghalibaf","moeen","karobi","ahmadi_nejad","rafsanjani")]/
  datuse[,"mehr_alizadeh"]);

datuse$ratio0905 <- datuse$total09/datuse$total05;
datuse$logratio0905 <- log(datuse$total09/datuse$total05);

# 2005 R1 vote * 2009/2005 total ratio

datuse$ratio0905 <- datuse$total09/datuse$total05;
datuse$logratio0905 <- log(datuse$total09/datuse$total05);

m0509ar <- multinomRob(list(
  Ahmadinejad ~ Llarijani*ratio0905 + Lghalibaf*ratio0905 + Lmoeen*ratio0905 +
    Lkarobi*ratio0905 + Lahmadi_nejad*ratio0905 + Lrafsanjani*ratio0905,
  Rezaei ~ Llarijani*ratio0905 + Lghalibaf*ratio0905 + Lmoeen*ratio0905 +
    Lkarobi*ratio0905 + Lahmadi_nejad*ratio0905 + Lrafsanjani*ratio0905,
  Karoubi ~ Llarijani*ratio0905 + Lghalibaf*ratio0905 + Lmoeen*ratio0905 +
    Lkarobi*ratio0905 + Lahmadi_nejad*ratio0905 + Lrafsanjani*ratio0905,
  Mousavi ~ 0), datuse, MLEonly=TRUE);
summary(m0509ar);
m0509ar <- multinomRob(list(
  Ahmadinejad ~ Llarijani*ratio0905 + Lghalibaf*ratio0905 + Lmoeen*ratio0905 +
    Lkarobi*ratio0905 + Lahmadi_nejad*ratio0905 + Lrafsanjani*ratio0905,
  Rezaei ~ Llarijani*ratio0905 + Lghalibaf*ratio0905 + Lmoeen*ratio0905 +
    Lkarobi*ratio0905 + Lahmadi_nejad*ratio0905 + Lrafsanjani*ratio0905,
  Karoubi ~ Llarijani*ratio0905 + Lghalibaf*ratio0905 + Lmoeen*ratio0905 +
    Lkarobi*ratio0905 + Lahmadi_nejad*ratio0905 + Lrafsanjani*ratio0905,
  Mousavi ~ 0), datuse, multinom.t=0, print=3);
summary(m0509ar);

# outliers from constant-vote-proportion model
linpred <- exp(cbind(1,
  as.matrix(datuse[,c("Llarijani","ratio0905","Lghalibaf","Lmoeen","Lkarobi","Lahmadi_nejad",
    "Lrafsanjani")]),
  as.matrix(datuse[,c("Llarijani","Lghalibaf","Lmoeen","Lkarobi","Lahmadi_nejad",
    "Lrafsanjani")])*datuse[,"ratio0905"] ) %*%
  m0509ar$coefficients);
pmat <- linpred/apply(linpred,1,sum);
rmat <-
  as.matrix(datuse[,c("Ahmadinejad","Rezaei","Karoubi","Mousavi")])/datuse$total09-pmat;
widx <- apply(m0509ar$weights[,-1]==0,1,any);
usermat <- rmat;
usermat[m0509ar$weights[,-1]!=0] <- NA;
cbind(datuse$obsnum[widx], usermat[widx,]);

# downweighted obs from constant-vote-proportion model
widx <- apply(m0509ar$weights[,-1]<1,1,any);
usermat <- rmat;
usermat[m0509ar$weights[,-1]==1] <- NA;
cbind(datuse$obsnum[widx], usermat[widx,]);
